/*
Interactions

`Interactions are managed by our flow designer in UI, what you can control via api is how you start and run interaction flow for contact sending events.  Interaction can start in a multiple ways:  - EntryPont - when contact scans QR code ar opens entry point link  - event as trigger - this way you can start flow for single contact  ## Events Events are a data structure related to some contact action. You can use them whenever you want to start active interaction for contact but also inside interaction flow you can define points wher system should wait for custom event sent from your side.   Depending on your use case our predefined interactions might have defined events and instruction what events should be sent.  Events can be sent directly using our REST Api or triggered automatically by our integration modules.  ## Adding attributes to events Adding attributest to event can personalize communication, select branch flow based on attribute value or use them as perameters in other interaction flow actions. Use `body` property in event structure to add key-value attributes. 

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package interactions

import (
	"encoding/json"
	"time"
)

// checks if the DataSourceDescriptorGroup type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &DataSourceDescriptorGroup{}

// DataSourceDescriptorGroup struct for DataSourceDescriptorGroup
type DataSourceDescriptorGroup struct {
	Id string `json:"id"`
	ParentId *string `json:"parent_id,omitempty"`
	Parent *DataSourceDescriptorGroup `json:"parent,omitempty"`
	// This is only set when group got created by system, in this case this kind of group can only be changed, but not removed
	Key *string `json:"key,omitempty"`
	Name string `json:"name"`
	Description *string `json:"description,omitempty"`
	CreatedAt time.Time `json:"created_at"`
	UpdatedAt time.Time `json:"updated_at"`
}

// NewDataSourceDescriptorGroup instantiates a new DataSourceDescriptorGroup object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewDataSourceDescriptorGroup(id string, name string, createdAt time.Time, updatedAt time.Time) *DataSourceDescriptorGroup {
	this := DataSourceDescriptorGroup{}
	this.Id = id
	this.Name = name
	this.CreatedAt = createdAt
	this.UpdatedAt = updatedAt
	return &this
}

// NewDataSourceDescriptorGroupWithDefaults instantiates a new DataSourceDescriptorGroup object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewDataSourceDescriptorGroupWithDefaults() *DataSourceDescriptorGroup {
	this := DataSourceDescriptorGroup{}
	return &this
}

// GetId returns the Id field value
func (o *DataSourceDescriptorGroup) GetId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Id
}

// GetIdOk returns a tuple with the Id field value
// and a boolean to check if the value has been set.
func (o *DataSourceDescriptorGroup) GetIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Id, true
}

// SetId sets field value
func (o *DataSourceDescriptorGroup) SetId(v string) {
	o.Id = v
}

// GetParentId returns the ParentId field value if set, zero value otherwise.
func (o *DataSourceDescriptorGroup) GetParentId() string {
	if o == nil || IsNil(o.ParentId) {
		var ret string
		return ret
	}
	return *o.ParentId
}

// GetParentIdOk returns a tuple with the ParentId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *DataSourceDescriptorGroup) GetParentIdOk() (*string, bool) {
	if o == nil || IsNil(o.ParentId) {
		return nil, false
	}
	return o.ParentId, true
}

// HasParentId returns a boolean if a field has been set.
func (o *DataSourceDescriptorGroup) HasParentId() bool {
	if o != nil && !IsNil(o.ParentId) {
		return true
	}

	return false
}

// SetParentId gets a reference to the given string and assigns it to the ParentId field.
func (o *DataSourceDescriptorGroup) SetParentId(v string) {
	o.ParentId = &v
}

// GetParent returns the Parent field value if set, zero value otherwise.
func (o *DataSourceDescriptorGroup) GetParent() DataSourceDescriptorGroup {
	if o == nil || IsNil(o.Parent) {
		var ret DataSourceDescriptorGroup
		return ret
	}
	return *o.Parent
}

// GetParentOk returns a tuple with the Parent field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *DataSourceDescriptorGroup) GetParentOk() (*DataSourceDescriptorGroup, bool) {
	if o == nil || IsNil(o.Parent) {
		return nil, false
	}
	return o.Parent, true
}

// HasParent returns a boolean if a field has been set.
func (o *DataSourceDescriptorGroup) HasParent() bool {
	if o != nil && !IsNil(o.Parent) {
		return true
	}

	return false
}

// SetParent gets a reference to the given DataSourceDescriptorGroup and assigns it to the Parent field.
func (o *DataSourceDescriptorGroup) SetParent(v DataSourceDescriptorGroup) {
	o.Parent = &v
}

// GetKey returns the Key field value if set, zero value otherwise.
func (o *DataSourceDescriptorGroup) GetKey() string {
	if o == nil || IsNil(o.Key) {
		var ret string
		return ret
	}
	return *o.Key
}

// GetKeyOk returns a tuple with the Key field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *DataSourceDescriptorGroup) GetKeyOk() (*string, bool) {
	if o == nil || IsNil(o.Key) {
		return nil, false
	}
	return o.Key, true
}

// HasKey returns a boolean if a field has been set.
func (o *DataSourceDescriptorGroup) HasKey() bool {
	if o != nil && !IsNil(o.Key) {
		return true
	}

	return false
}

// SetKey gets a reference to the given string and assigns it to the Key field.
func (o *DataSourceDescriptorGroup) SetKey(v string) {
	o.Key = &v
}

// GetName returns the Name field value
func (o *DataSourceDescriptorGroup) GetName() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Name
}

// GetNameOk returns a tuple with the Name field value
// and a boolean to check if the value has been set.
func (o *DataSourceDescriptorGroup) GetNameOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Name, true
}

// SetName sets field value
func (o *DataSourceDescriptorGroup) SetName(v string) {
	o.Name = v
}

// GetDescription returns the Description field value if set, zero value otherwise.
func (o *DataSourceDescriptorGroup) GetDescription() string {
	if o == nil || IsNil(o.Description) {
		var ret string
		return ret
	}
	return *o.Description
}

// GetDescriptionOk returns a tuple with the Description field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *DataSourceDescriptorGroup) GetDescriptionOk() (*string, bool) {
	if o == nil || IsNil(o.Description) {
		return nil, false
	}
	return o.Description, true
}

// HasDescription returns a boolean if a field has been set.
func (o *DataSourceDescriptorGroup) HasDescription() bool {
	if o != nil && !IsNil(o.Description) {
		return true
	}

	return false
}

// SetDescription gets a reference to the given string and assigns it to the Description field.
func (o *DataSourceDescriptorGroup) SetDescription(v string) {
	o.Description = &v
}

// GetCreatedAt returns the CreatedAt field value
func (o *DataSourceDescriptorGroup) GetCreatedAt() time.Time {
	if o == nil {
		var ret time.Time
		return ret
	}

	return o.CreatedAt
}

// GetCreatedAtOk returns a tuple with the CreatedAt field value
// and a boolean to check if the value has been set.
func (o *DataSourceDescriptorGroup) GetCreatedAtOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return &o.CreatedAt, true
}

// SetCreatedAt sets field value
func (o *DataSourceDescriptorGroup) SetCreatedAt(v time.Time) {
	o.CreatedAt = v
}

// GetUpdatedAt returns the UpdatedAt field value
func (o *DataSourceDescriptorGroup) GetUpdatedAt() time.Time {
	if o == nil {
		var ret time.Time
		return ret
	}

	return o.UpdatedAt
}

// GetUpdatedAtOk returns a tuple with the UpdatedAt field value
// and a boolean to check if the value has been set.
func (o *DataSourceDescriptorGroup) GetUpdatedAtOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return &o.UpdatedAt, true
}

// SetUpdatedAt sets field value
func (o *DataSourceDescriptorGroup) SetUpdatedAt(v time.Time) {
	o.UpdatedAt = v
}

func (o DataSourceDescriptorGroup) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o DataSourceDescriptorGroup) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["id"] = o.Id
	if !IsNil(o.ParentId) {
		toSerialize["parent_id"] = o.ParentId
	}
	if !IsNil(o.Parent) {
		toSerialize["parent"] = o.Parent
	}
	if !IsNil(o.Key) {
		toSerialize["key"] = o.Key
	}
	toSerialize["name"] = o.Name
	if !IsNil(o.Description) {
		toSerialize["description"] = o.Description
	}
	toSerialize["created_at"] = o.CreatedAt
	toSerialize["updated_at"] = o.UpdatedAt
	return toSerialize, nil
}

type NullableDataSourceDescriptorGroup struct {
	value *DataSourceDescriptorGroup
	isSet bool
}

func (v NullableDataSourceDescriptorGroup) Get() *DataSourceDescriptorGroup {
	return v.value
}

func (v *NullableDataSourceDescriptorGroup) Set(val *DataSourceDescriptorGroup) {
	v.value = val
	v.isSet = true
}

func (v NullableDataSourceDescriptorGroup) IsSet() bool {
	return v.isSet
}

func (v *NullableDataSourceDescriptorGroup) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableDataSourceDescriptorGroup(val *DataSourceDescriptorGroup) *NullableDataSourceDescriptorGroup {
	return &NullableDataSourceDescriptorGroup{value: val, isSet: true}
}

func (v NullableDataSourceDescriptorGroup) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableDataSourceDescriptorGroup) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


